/* plan9-related stuff */
#include <u.h>
#include <libc.h>
#include <draw.h>
#include <event.h>
#include <thread.h>

#define NULL nil
#define XPoint Point
#define XImage Image
#define NRAND nrand
#define LRAND lrand
#define random lrand
#define MAXRAND ((2<<30)-1)
#define MAX(a, b) (((a) > (b))?(a):(b))
#define MIN(a, b) (((a) < (b))?(a):(b))
#define ABS abs
#define M_PI PI
#define M_PI_4 PIO2/2.0
#define M_PI_2 PIO2
#define M_SQRT2 1.41421356237309504880
#define Bool int
#define True 1
#define False 0

Image *colors[256];
Image *color;

uchar *buf;	/* buffer for loadimage */
Image *img;	/* image to load to */


typedef struct XRectangle XRectangle;
struct XRectangle {
	int x, y, width, height;
};

typedef struct XColor XColor;
struct XColor {
	ushort red;
	ushort green;
	ushort blue;
};

XColor rgb[256];

typedef struct XSegment XSegment;
struct XSegment {
	int x1, y1;
	int x2, y2;
};

typedef struct XArc XArc;
struct XArc{
	int x;
	int y;
	int width;
	int height;
	int angle1;
	int angle2;
};

char *buttons[] = 
{
	"exit",
	0
};

Menu menu = 
{
	buttons
};
Mouse m;


/* benchmarking */
void
usage(void)
{
	fprint(2, "%s: [-b benchtime]\n", argv0);
	threadexitsall("usage");
}

vlong tbegin, tend;
ulong frames, btime;

void
dofps(void *)
{
	tbegin = nsec();
	sleep(btime*1000);	/* in milliseconds */
	tend = nsec();
	print("fps: %uf\n", frames/((tend - tbegin)/1000000000.0));

	threadexitsall(nil);
}

/* we need this because some of the programs fill out the whole stack */
int mainstacksize = 8192;
/* end of plan9-related stuff */
